<?

class PortalConnect extends BaseObject {

var $url;
var $fetcher;

var $userId;
var $userLogin;
var $userPassword;
var $userPwEncType;

var $connected;
var $sessionId;
var $cookieName;

var $source;
var $returnCode;
var $returnParams;
var $messages;

var $errors;

function PortalConnect($url, $fetcher = null, $cookieName = "JSESSIONID") {
global $USER_ID;
$this->url = $url;
$this->fetcher = is_a($fetcher, "fetchurl") ? $fetcher : new fetchCurl();
$this->setAuthUserId($USER_ID);
$this->connected = false;
$this->cookieName = $cookieName;
$this->_cleanupValues();
}

function getPortalUrl() {
return $this->url;
}

function setPortalUrl($url) {
if ($this->url == $url) return;

if ($this->isConnected()) {
$this->disconnect();
}
$this->url = $url;
}

function &getFetcher($fetcher) {
return $this->fetcher;
}

/**
  *                              /        
  *                                                                    
  */
function setAuthUserId($userId) {
$this->userId = $userId;
$this->userLogin = false;
$this->userPassword = false;
$this->userPwEncType = "clear";
}

/**
  *                               
  */
function setAuthUserLogin($login, $password, $encryption = "clear") {
$this->userId = false;
$this->userLogin = $login;
$this->userPassword = $password;
$this->userPwEncType = $encryption;
}

function setAuthentication($authKey) {
//                                                
 }

function isConnected() {
return $this->connected;
}

/**
  *                                            
  *                                     
  */
function connect($reuseCookie = false) {
$this->connected = false;

$cookie = $this->fetcher->getReceivedCookie($this->cookieName);
if (!$cookie || !$reuseCookie) {
$url = $this->_getLoginUrl();

$this->fetcher->setHandleCookies(true);
$this->fetcher->reset(!$reuseCookie);
$this->fetcher->sendRequest($url);

$cookie = $this->fetcher->getReceivedCookie($this->cookieName);
}

if ($cookie) {
$this->sessionId = $cookie->getValue();

//                                                                          
 
$this->connected = true;
}

return $this->connected;
}

function disconnect() {
$this->sessionId = false;
$this->connected = false;
}

/**
  *                                           
  **/
function isValidRequest() {
$cookie = $this->fetcher->getReceivedCookie($this->cookieName);
if ($cookie) {
if ($this->sessionId != $cookie->getValue()) return false;
}
//                                                               
 if (!$this->returnCode) {
return false;
}
//                                                     
 return true;
}

/**
  *                                                             
  * 
  *                                                                                          
  *                                                             
  **/
function query($portlet, $params, $action = true) {

$code = $this->_query($portlet, $params, $action);

//                                                       
 if (!$this->isValidRequest()) {

$this->messages[] = array("level"=>"DEBUG", "category"=>"Connection failure", "code"=>"Trying to reconnect");

if (!$this->connect(true)) {
$this->messages[] = array("level"=>"ERROR", "category"=>"Connection failure", "code"=>"Could not reconnect to server (".$this->url.").");
return false;
}

$code = $this->_query($portlet, $params, $action);
}

return $code;
}

function getReturnCode() {
return $this->returnCode;
}

function getMessages() {
return $this->messages;
}

function getResultParams() {
return $this->returnParams;
}

function cleanup() {
$this->fetcher->reset();
$this->_cleanupValues();
}

function _getLoginUrl() {
//                                              
 return $this->url;
}

function _getActionUrl($portlet, $action = true, $pbox = false, $state = "gti_full") {

$url = $this->url."?gentics.ts=".time();

if ($action) {
$url .= "&gentics.am=$portlet";
}

$url .= "&gentics.pm=$state";
$url .= "&gentics.pb=".($pbox?$pbox:$portlet);

return $url;
}

function _query($portlet, $params, $action) {

$this->cleanup();
$source = false;

$url = $this->_getActionUrl($portlet, $action);

//                      
 foreach ($params as $key=>$param) {
if (is_array($param)) {
foreach($param as $p) {
$url .= "&p.$key=".urlencode($p);
}
} else {
$url .= "&p.$key=".urlencode($param);
}
}

$code = $this->fetcher->sendRequest($url);

//     /                   
 if ($code) {		
$source = $this->_loadCode($code);
if ($this->returnCode == false) {
$source = false;
}
}

return $source;
}

function _loadCode($code) {

$lastPos = 0;
$num = 0;
$msgPos = count($this->messages) - 1;
$paramName = "";
$paramNum = 0;
$isMsg = true;

$this->source = false;

while (($pos = strpos($code, "\n", $lastPos)) !== false) {
$line = str_replace("\r", "", substr($code, $lastPos, $pos - $lastPos));

if ($num == 0) {

//           
 $ret = $this->_parseReturnCode($line);
if ($ret === false) {
$this->messages[] = array("level"=>"ERROR", "category"=>"Invalid returncode", "code"=>"Invalid returncode {".$line."}.");
break;
} else {
$this->returnCode = $ret;
}

} else if ($line == "") {

//                                              
 $this->source = substr($code, $pos + 1);
break;

} else if (substr($line, 0, 1) == " ") {

//                       /     
 $line = substr($line, 1);
if ($isMsg && $msgPos > -1) {
$this->messages[$msgPos]["code"] .= $line;
} else if (!$isMsg) {
$this->returnParams[$paramName][$paramNum] .= "\n".$line;
}

} else {

//        /          
 //                   
 $type = substr($line, 0, 1);
if (substr($line, 1, 1) != ";") {
//              
 $this->messages[] = array("level"=>"ERROR", "category"=>"Invalid returncode", "code"=>"Missing ';' in header.");
break;
}

$mpos = strpos($line, ";", 2);
if (!$mpos) {
$this->messages[] = array("level"=>"ERROR", "category"=>"Invalid returncode", "code"=>"Missing ';' in header.");
break;
}

$name = substr($line, 2, $mpos - 2);
$value = ($mpos + 1 < strlen($line)) ? substr($line, $mpos + 1) : "";

if ($type == "p") {
$isMsg = false;
$paramName = $name;					
$paramNum = isset($this->returnParams[$paramName]) ? count($this->returnParams[$paramName]) : 0 ;

$this->returnParams[$paramName][$paramNum] = $value;

} else if ($type == "m") {
$isMsg = true;
$info = explode(":", $name);

$msgPos++;
$this->messages[$msgPos] = array("level"=>$info[0], "category"=>$info[1], "code"=>$value);
}
}

$num++;
$lastPos = $pos + 1;
}

return $this->source;
}

/**
  *                                
  *                               
  *
  *                                         
  **/
function _parseReturnCode($line) {
if (!ereg("^CM/2 (.*)$", $line, $reg)) {
return false;
}
return $reg[1];
}

function _cleanupValues() {
$this->returnCode = false;
$this->returnParams = array();
$this->source = "";
$this->messages = array();
$this->errors = array();
}
}

class PortalConnectFactory {

function initialize() {
global $PORTALCONNECTS_PERSIST, $PORTALCONNECTS, $PORTALCONNECTS_SESSION;

if (!$PORTALCONNECTS_SESSION) {
$PORTALCONNECTS_PERSIST = new PortalConnectPool();
} else {
$PORTALCONNECTS_PERSIST = node_unserialize($PORTALCONNECTS_SESSION);
}

if (!is_object($PORTALCONNECTS)) {
$PORTALCONNECTS = new PortalConnectPool();
}
}

function store() {
global $PORTALCONNECTS_PERSIST, $PORTALCONNECTS_SESSION;

if (is_object($PORTALCONNECTS_PERSIST)) {
$PORTALCONNECTS_SESSION = node_serialize($PORTALCONNECTS_PERSIST);
} else {
$PORTALCONNECTS_SESSION = false;
}
}

/**
  *                                                                                                    
  **/
function &getConnection($name) {
global $PORTALCONNECTS_PERSIST, $PORTALCONNECTS;

$connect = null;

if ($PORTALCONNECTS_PERSIST->keyExists($name)) {
$connect =& $PORTALCONNECTS_PERSIST->getByKey($name);;
} else if ($PORTALCONNECTS->keyExists($name)) {
$connect =& $PORTALCONNECTS->getByKey($name);
}

return $connect;
}

function &createConnection($name, $url, $fetcher = null, $cookieName = "JSESSIONID", $session = true) {
global $PORTALCONNECTS_PERSIST, $PORTALCONNECTS;

//                                                          
 //                           
 $connect = new ServletConnect($url, $fetcher, $cookieName);

if ($session) {
$PORTALCONNECTS_PERSIST->add($name,$connect);
} else {
$PORTALCONNECTS->add($name,$connect);
}

return $connect;
}

}

/**
 *                                                                                       
 **/
class PortalConnectPool extends BaseObject {

var $connects;

function PortalConnectPool() {
$this->connects = array();
}

function add($key, &$connect) {
unset($this->connects[$key]);
$this->connects[$key] =& $connect;
}

function &getByKey($key) {
return $this->connects[$key];
}

function keyExists($key) {
return isset($this->connects[$key]);
}

function getSerializeKey() {
$key = array();
$key["connects"] = array();
foreach ($this->connects as $name=>$connect) {
$connect->cleanup();
$key["connects"][$name] = node_serialize($connect);
}
return $key;
}

function initFromSerializeKey($key) {
$this->connects = array();
foreach ($key["connects"] as $name=>$connect) {
$this->connects[$name] =& node_unserialize($connect);
}
}

}

function portalconnect_register() {

mysession_var_reg("PORTALCONNECTS_SESSION");

PortalConnectFactory::initialize();
}

function portalconnect_store() {

PortalConnectFactory::store();

}

$EXEC_FUNC[] = "portalconnect_register";
$DESTROY_FUNC[] = "portalconnect_store";

?>
