/**
 * QuickJump manager
 */
var GTXQuickJump = {
	/**
	 * autocomplete url appendix (do)
	 */
	AUTOCOMPLETE_URL_APPENDIX: "&do=14019",
	
	/**
	 * initializes the quickjumper
	 * @param string STAG
	 * @param bool fade quickjumper on submit event
	 * @return void
	 */
	init: function(sTag, fadeOnSubmit) {
		// turn input field into autocomplete
		jQuery("#pagejump").autocomplete(sTag + this.AUTOCOMPLETE_URL_APPENDIX, {
			delay: 250,
			width: 200,
			max: 15
		}).result(this.formatResult);
		if (fadeOnSubmit) {
			jQuery("#quickjump form").submit(function () {
				jQuery('#quickjump').fadeOut("fast");
				jQuery("#treeTable").fadeTo("normal", 1);
			});
		}
		jQuery("#pagejumpId").attr("value", "");
	},
	
	/**
	 * show the qickjumper
	 * @return void
	 */
	show: function() {
    	jQuery("#treeTable").fadeTo("normal", .4);
    	jQuery('#quickjump').fadeIn("fast");
		jQuery("#pagejump").focus();		
	},
	
	/**
	 * hide the quickjumper
	 * @return void
	 */
	hide: function() {
		jQuery('#quickjump').fadeOut("fast");
		jQuery("#treeTable").fadeTo("normal", 1);
	},
	
	/**
	 * this is triggered when a result is selected from the list
	 * @param object event object
	 * @param array data that has been selected
	 * @param string formatted version of data
	 */
	formatResult: function(event, data, formatted) {
		pageName = data[0].replace(/.*<div class="ac_page"[^>]+>(.+)<\/div>$/, "$1");
		pageId = data[0].replace(/.*<div class="ac_page" page_id="(\d+)">.+<\/div>$/, "$1");
		jQuery("#pagejump").attr("value", pageName);
		jQuery("#pagejumpId").attr("value", pageId);
		jQuery("#quickjump form").submit();
	}
};