<?php

/**
 *                                                                 
 *                                                                      
 *           /                          /                       
 * 
 *                                                                                         
 *                         /                      *         *                             
 *                                   
 **/

class TimeLogger
{
var $d_name;
var $d_totalTime;
var $d_count;
var $d_sTime;
var $d_showNeverEncountered;


/**
  *                         
  * 
  *             
  * 
  *                                                                        
  *         
  **/
function TimeLogger( $name, $showEmptyLogs = TRUE )
{
$this->d_name = $name;
$this->d_showNeverEncountered = $showEmptyLogs;
$this->reset();
}

/**
  *                           
  * 
  *         
  *                                              
  * 
  *                                            
  **/
function getMicroTime()
{
list($usec, $sec) = explode(" ",microtime());
return ((float)$usec + (float)$sec);
}


/**
  *                    
  * 
  *                          
  * 
  *         
  **/
function start()
{
$this->d_sTime = $this->getMicroTime();
$this->d_count ++;
}


/**
  *                   
  * 
  *                          
  * 
  *         
  **/
function stop()
{
$this->d_totalTime += $this->getMicroTime() - $this->d_sTime;
}

/**
  *                    
  * 
  *                   
  * 
  *         
  **/
function reset()
{
$this->d_count = 0;
$this->d_totalTime = 0;
}

/**
  *                             
  * 
  *                                                                                     
  **/
function getTotalInTime()
{
return $this->d_totalTime;
}

/**
  *                           
  * 
  *                                                                                       
  **/
function getAvgInTime()
{
if ( $this->d_count > 0 )
return $this->d_totalTime / $this->d_count;
return "N/A";
}

/**
  *                                      
  * 
  *                                            
  **/
function getFormattedTotalInTime()
{
return gmdate( "H:i:s", $this->d_totalTime );
}

/**
  *                                    
  * 
  *                                          
  **/
function getFormattedAvgInTime()
{
$span = $this->d_totalTime / $this->d_count;

return gmdate( "H:i:s", $span ) . "." . $this->fpart($span, 3);
}


/**
  *                    
  * 
  *         
  *                                           
  * 
  *                                                                
  *                                                                    
  *                                                 
  *                                          
  **/
function fpart( $i, $count = 2 )
{
$part = $i - floor($i);
$part = substr( $part, 2, $count );
return $part;
}


/**
  *                       
  * 
  *                                                             
  **/
function toString()
{
if ( $this->d_count )
{
return "<table border=1>" .
"<tr><td colspan=2><H3>Time in <b>".$this->d_name."</b></H3></td></tr>" .
"<tr><td>Total:</td><td align=right>".$this->getFormattedTotalInTime()."</td></tr>" .
"<tr><td>In-Count:</td><td align=right>".$this->d_count."</td></tr>" .
"<tr><td>Average:</td><td align=right>".$this->getFormattedAvgInTime()."</td></tr>" .
"</table>";


}
else if ( $this->d_showNeverEncountered )
return "<table border=1>" .
"<tr><td colspan><H3>Time in <b>".$this->d_name."</b></H3></td></tr>" .
"<tr><td>Never encountered</td></tr>" .
"</table>";
else
return "";
}
};


?>