<?php
/*
                                                           

                                     

                                       

                                                          /  
                                                          
                                                            
                                                                  

                                                               
                                                              
                                                                 
                                               

                                                                
                                                                   
                                                                         

                                                    

              
                  
     //                  /      

                    
     //                

*/

/*                           */
/*                        */
require_once('Mail/mimeDecode.php');
require_once('Mail/mimePart.php');

/**
*                                                             
*      //          /  /                                                            
*
*                                                 
*                                                                                                 
*                                                                      
*                 
*/
class soapclientmime extends soapclient {
/**
  *                                                                              
  *                                 
  *                
  */
var $requestAttachments = array();
/**
  *                                                                              
  *                                 
  *                
  */
var $responseAttachments;
/**
  *            
  *                
  */
var $mimeContentType;

/**
 *                                               
 *
 *                                                                       
 *                                                           
 *
 *                                                                   
 *
 *                                               
 *                                                                                 
 *                                                                                           /             
 *                                                                             
 *                                                      
 *               
 */
function addAttachment($data, $filename = '', $contenttype = 'application/octet-stream', $cid = false) {
if (! $cid) {
$cid = md5(uniqid(time()));
}

$info['data'] = $data;
$info['filename'] = $filename;
$info['contenttype'] = $contenttype;
$info['cid'] = $cid;

$this->requestAttachments[] = $info;

return $cid;
}

/**
 *                                                     
 *
 *               
 */
function clearAttachments() {
$this->requestAttachments = array();
}

/**
 *                                                     
 *
 *                                                                   
 *                                                                           
 *                   
 *
 *                               
 *               
 */
function getAttachments() {
return $this->responseAttachments;
}

/**
 *                                            
 *
 *                                        
 *                                                              
 *                
 */
function getHTTPBody($soapmsg) {
if (count($this->requestAttachments) > 0) {
$params['content_type'] = 'multipart/related; type=text/xml';
$mimeMessage =& new Mail_mimePart('', $params);
unset($params);

$params['content_type'] = 'text/xml';
$params['encoding']     = '8bit';
$params['charset']      = $this->soap_defencoding;
$mimeMessage->addSubpart($soapmsg, $params);

foreach ($this->requestAttachments as $att) {
unset($params);

$params['content_type'] = $att['contenttype'];
$params['encoding']     = 'base64';
$params['disposition']  = 'attachment';
$params['dfilename']    = $att['filename'];
$params['cid']          = $att['cid'];

if ($att['data'] == '' && $att['filename'] <> '') {
if ($fd = fopen($att['filename'], 'rb')) {
$data = fread($fd, filesize($att['filename']));
fclose($fd);
} else {
$data = '';
}
$mimeMessage->addSubpart($data, $params);
} else {
$mimeMessage->addSubpart($att['data'], $params);
}
}

$output = $mimeMessage->encode();
$mimeHeaders = $output['headers'];

foreach ($mimeHeaders as $k => $v) {
$this->debug("MIME header $k: $v");
if (strtolower($k) == 'content-type') {
//                                                        
 //                                                 
 $this->mimeContentType = str_replace("\r\n", " ", $v);
}
}

return $output['body'];
}

return parent::getHTTPBody($soapmsg);
}

/**
 *                                                    
 *
 *                                              
 *
 *                                                              
 *                
 */
function getHTTPContentType() {
if (count($this->requestAttachments) > 0) {
return $this->mimeContentType;
}
return parent::getHTTPContentType();
}

/**
 *                                                            
 *                                          
 *
 *                                              
 *
 *                                                                      
 *                
 */
function getHTTPContentTypeCharset() {
if (count($this->requestAttachments) > 0) {
return false;
}
return parent::getHTTPContentTypeCharset();
}

/**
 *                                            
 *
 *                                       
 *                                                           
 *                                                            
 *                  
 */
function parseResponse($headers, $data) {
$this->debug('Entering parseResponse() for payload of length ' . strlen($data) . ' and type of ' . $headers['content-type']);
$this->responseAttachments = array();
if (strstr($headers['content-type'], 'multipart/related')) {
$this->debug('Decode multipart/related');
$input = '';
foreach ($headers as $k => $v) {
$input .= "$k: $v\r\n";
}
$params['input'] = $input . "\r\n" . $data;
$params['include_bodies'] = true;
$params['decode_bodies'] = true;
$params['decode_headers'] = true;

$structure = Mail_mimeDecode::decode($params);

foreach ($structure->parts as $part) {
if (!isset($part->disposition)) {
$this->debug('Have root part of type ' . $part->headers['content-type']);
$return = parent::parseResponse($part->headers, $part->body);
} else {
$this->debug('Have an attachment of type ' . $part->headers['content-type']);
$info['data'] = $part->body;
$info['filename'] = isset($part->d_parameters['filename']) ? $part->d_parameters['filename'] : '';
$info['contenttype'] = $part->headers['content-type'];
$info['cid'] = $part->headers['content-id'];
$this->responseAttachments[] = $info;
}
}

if (isset($return)) {
return $return;
}

$this->setError('No root part found in multipart/related content');
return;
}
$this->debug('Not multipart/related');
return parent::parseResponse($headers, $data);
}
}

/**
*                                                               
*      //          /  /                                                            
*
*                                                 
*                                                                                                 
*                                                                      
*                 
*/
class nusoapservermime extends soap_server {
/**
  *                                                                              
  *                                 
  *                
  */
var $requestAttachments = array();
/**
  *                                                                              
  *                                 
  *                
  */
var $responseAttachments;
/**
  *            
  *                
  */
var $mimeContentType;

/**
 *                                                
 *
 *                                                                       
 *                                                           
 *
 *                                                                   
 *
 *                                               
 *                                                                                 
 *                                                                                           /             
 *                                                                             
 *                                                      
 *               
 */
function addAttachment($data, $filename = '', $contenttype = 'application/octet-stream', $cid = false) {
if (! $cid) {
$cid = md5(uniqid(time()));
}

$info['data'] = $data;
$info['filename'] = $filename;
$info['contenttype'] = $contenttype;
$info['cid'] = $cid;

$this->responseAttachments[] = $info;

return $cid;
}

/**
 *                                                      
 *
 *               
 */
function clearAttachments() {
$this->responseAttachments = array();
}

/**
 *                                                    
 *
 *                                                                   
 *                                                                           
 *                   
 *
 *                               
 *               
 */
function getAttachments() {
return $this->requestAttachments;
}

/**
 *                                             
 *
 *                                        
 *                                                              
 *                
 */
function getHTTPBody($soapmsg) {
if (count($this->responseAttachments) > 0) {
$params['content_type'] = 'multipart/related; type=text/xml';
$mimeMessage =& new Mail_mimePart('', $params);
unset($params);

$params['content_type'] = 'text/xml';
$params['encoding']     = '8bit';
$params['charset']      = $this->soap_defencoding;
$mimeMessage->addSubpart($soapmsg, $params);

foreach ($this->responseAttachments as $att) {
unset($params);

$params['content_type'] = $att['contenttype'];
$params['encoding']     = 'base64';
$params['disposition']  = 'attachment';
$params['dfilename']    = $att['filename'];
$params['cid']          = $att['cid'];

if ($att['data'] == '' && $att['filename'] <> '') {
if ($fd = fopen($att['filename'], 'rb')) {
$data = fread($fd, filesize($att['filename']));
fclose($fd);
} else {
$data = '';
}
$mimeMessage->addSubpart($data, $params);
} else {
$mimeMessage->addSubpart($att['data'], $params);
}
}

$output = $mimeMessage->encode();
$mimeHeaders = $output['headers'];

foreach ($mimeHeaders as $k => $v) {
$this->debug("MIME header $k: $v");
if (strtolower($k) == 'content-type') {
//                                                        
 //                                                 
 $this->mimeContentType = str_replace("\r\n", " ", $v);
}
}

return $output['body'];
}

return parent::getHTTPBody($soapmsg);
}

/**
 *                                                     
 *
 *                                              
 *
 *                                                               
 *                
 */
function getHTTPContentType() {
if (count($this->responseAttachments) > 0) {
return $this->mimeContentType;
}
return parent::getHTTPContentType();
}

/**
 *                                                             
 *                                          
 *
 *                                              
 *
 *                                                                       
 *                
 */
function getHTTPContentTypeCharset() {
if (count($this->responseAttachments) > 0) {
return false;
}
return parent::getHTTPContentTypeCharset();
}

/**
 *                                            
 *
 *                                       
 *                                                          
 *                                                            
 *                  
 */
function parseRequest($headers, $data) {
$this->debug('Entering parseRequest() for payload of length ' . strlen($data) . ' and type of ' . $headers['content-type']);
$this->requestAttachments = array();
if (strstr($headers['content-type'], 'multipart/related')) {
$this->debug('Decode multipart/related');
$input = '';
foreach ($headers as $k => $v) {
$input .= "$k: $v\r\n";
}
$params['input'] = $input . "\r\n" . $data;
$params['include_bodies'] = true;
$params['decode_bodies'] = true;
$params['decode_headers'] = true;

$structure = Mail_mimeDecode::decode($params);

foreach ($structure->parts as $part) {
if (!isset($part->disposition)) {
$this->debug('Have root part of type ' . $part->headers['content-type']);
$return = parent::parseRequest($part->headers, $part->body);
} else {
$this->debug('Have an attachment of type ' . $part->headers['content-type']);
$info['data'] = $part->body;
$info['filename'] = isset($part->d_parameters['filename']) ? $part->d_parameters['filename'] : '';
$info['contenttype'] = $part->headers['content-type'];
$info['cid'] = $part->headers['content-id'];
$this->requestAttachments[] = $info;
}
}

if (isset($return)) {
return $return;
}

$this->setError('No root part found in multipart/related content');
return;
}
$this->debug('Not multipart/related');
return parent::parseRequest($headers, $data);
}
}
?>
